package org.code_blue.dmxcremote.v2;

import org.code_blue.dmxcremote.v2.classes.DMXConnection;

import android.app.Activity;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Bundle;
import android.os.Message;
import android.util.Log;
import android.view.Window;
import android.widget.TextView;

public class DeviceControlActivity extends Activity {
	private ControlsUpdater updater=new ControlsUpdater();
	private DMXConnection dmxConn;
	
	private String deviceName=new String("No Device");
	private int startingAddress=0;
	private int channelCount=0;
	
	@Override
	public void onCreate(Bundle b){
		super.onCreate(b);
		requestWindowFeature(Window.FEATURE_NO_TITLE);
		dmxConn=((RemoteApp)getApplication()).getDMXConnection();
		setContentView(R.layout.devicecontrol_mask);
	}
	
	@Override
	protected void onResume(){
		super.onResume();
		
    	Bundle extras = getIntent().getExtras(); 
    	if(extras==null){
    		Log.d("DMX","got no device!");
    		Message m=((RemoteApp)getApplication()).getApplicationHandler().obtainMessage(0,RemoteApp.HANDLE.DISPLAYTOAST);
    		m.getData().putString("message","Internal Error (No IAC)");
    		m.sendToTarget();
    		return;
    	}	
    	int deviceIndex = extras.getInt("device");
		
		registerReceiver(updater,new IntentFilter("org.code_blue.dmxcremote.v2.DATAREADY"));
		dmxConn.requestDeviceInfo(deviceIndex);
	}
	
	@Override
	protected void onPause(){
		super.onPause();
		unregisterReceiver(updater);
	}
	
	private class ControlsUpdater extends BroadcastReceiver{
		@Override
		public void onReceive(Context c, Intent i) {
			Log.d("DMX","got devinfo: "+i.getStringExtra("data"));
			String[] devInfo=i.getStringExtra("data").split("\\n");
			
			//FIXME UGLY HACK: ONCE AGAIN; BAD DESIGN COUNTERED WITH MORE BAD DESIGN
			try{
				deviceName=devInfo[0].substring(devInfo[0].indexOf(": ")+2);
				Log.d("DMX","extracted devName="+deviceName);
				((TextView)findViewById(R.id.devicecontrolmaskDeviceName)).setText(deviceName);
				
				startingAddress=Integer.valueOf(devInfo[1].substring(devInfo[1].indexOf(": ")+2));
				Log.d("DMX","read startAddr "+startingAddress);
				
				channelCount=Integer.valueOf(devInfo[3].substring(devInfo[3].indexOf(": ")+2));
				Log.d("DMX","read chanCount "+channelCount);
				
				((TextView)findViewById(R.id.devicecontrolmaskDeviceInfo)).setText("Address: "+startingAddress+" | Channels: "+channelCount);
			}
			catch(IndexOutOfBoundsException e){
				Log.d("DMX","dmxcontrol sent malformed data (general)");
			}
			catch(NumberFormatException e){
				Log.d("DMX","dmxcontrol sent malformed data (integer)");
			}
		}
	}
}
